import es
import playerlib
import gamethread

import wcs
from wcs import wcs

Name   = 'Angel'
race   = wcs.Race(Name)
weapon = 'knife'

race.registerAuthor('||Wolf||')
race.registerWeaponRestriction('allow only', weapon)

####################
config = race.config()
text   = race.loadStrings()

config.addComment('********************')
config.addComment('Angelic Speed')
config.addComment(' The heavens bless you with speed.')
config.addComment('********************')
config.addComment()

speedMaxLevel      = config.addVar('speedMaxLevel',      7, 'Max Level')
speedLevelInterval = config.addVar('speedLevelInterval', 1, 'Level Interval')
speedAmount        = config.addVar('speedAmount',     0.07, 'Speed Amount Per Level')

config.addComment('********************')
config.addComment('Holy Dagger')
config.addComment(' You make your dagger holy.')
config.addComment('********************')
config.addComment()

daggerMaxLevel      = config.addVar('daggerMaxLevel',     10, 'Max Level')
daggerLevelInterval = config.addVar('daggerLevelInterval', 1, 'Level Interval')
daggerDamage        = config.addVar('daggerDamage',      0.1, 'Damage Amount Per Level')

config.addComment('********************')
config.addComment('Blinding Aura')
config.addComment(' Show off your beauty and blind nearby enemies. <+Ability>')
config.addComment('********************')
config.addComment()

auraMaxLevel      = config.addVar('auraMaxLevel',      5, 'Max Level')
auraLevelInterval = config.addVar('auraLevelInterval', 1, 'Level Interval')
auraDistance      = config.addVar('auraDistance',     80, 'Distance increase Per Level')

config.addComment('********************')
config.addComment('Angelic Wings')
config.addComment(' Use your wings to fly to the heavens. <+Ultimate>')
config.addComment('********************')
config.addComment()

wingsMinLevel      = config.addVar('wingsMinLevel',     16, 'Min Level')
wingsMaxLevel      = config.addVar('wingsMaxLevel',      1, 'Max Level')
wingsLevelInterval = config.addVar('wingsLevelInterval', 1, 'Level Interval')

config.load(True)
####################

race.registerSkill('Angelic Speed', int(speedMaxLevel),  int(speedLevelInterval),  'The heavens bless you with speed.')
race.registerSkill('Holy Dagger',   int(daggerMaxLevel), int(daggerLevelInterval), 'You make your dagger holy.')
race.registerSkill('Blinding Aura', int(auraMaxLevel),   int(auraLevelInterval),   'Show off your beauty and blind nearby enemies. <+Ability>')

race.registerUltimate('Angelic Wings', int(wingsMinLevel), int(wingsMaxLevel), int(wingsLevelInterval), 'Use your wings to fly to the heavens. <+Ultimate>')

def player_spawn(ev):
    userid = ev['userid']

    if wcs.GetRace(userid) == Name:   
        wcs.Command(userid).SetGravity(0.7)
    
        aSpeed = wcs.GetLevel(userid, Name, 'Angelic Speed')
        speed = float(aSpeed * speedAmount)
        if speed:
            wcs.Command(userid).SpeedAdd(speed)
            es.tell(userid,'#multi','#greenAngelic Speed #default- #lightgreenThe heavens have given you \'#green%s#lightgreen\' more speed.' %speed)

def player_hurt(ev):
    userid   = ev['userid']
    attacker = ev['attacker']
    damage   = int(ev['dmg_health'])

    hDagger = wcs.GetLevel(attacker, Name, 'Holy Dagger')
    hDamage = float(hDagger * daggerDamage)
    if hDagger:
        wcs.Command(userid).Damage(damage * hDamage, 4, attacker)
        es.tell(attacker, '#multi', '#greenHoly Dagger #default- #lightgreenYou have dealt \'#green%s#lightgreen\' extra damage.' %(damage*hDamage))
        es.tell(userid,   '#multi', '#greenHoly Dagger #default- #lightgreenYou have been hit by \'#green%s\'s#lightgreen\' holy dagger.'  %es.getplayername(attacker))

def player_ability_on(ev):
    userid = ev['userid']
    team   = es.getplayerteam(userid)
    if team == 2:
        filter = '#ct'
    elif team == 3:
        filter = '#t'
        
    bAura = wcs.GetLevel(userid, Name, 'Blinding Aura')
    bDistance = bAura * auraDistance
    if bAura:
        if not wcs.Command(userid).GetCoolDown('Blinding Aura'):
            es.tell(userid, '#multi', '#greenBlinding Aura #default- #lightgreenActivated.')
            wcs.Command(userid).Near(bDistance, Blind, filter)
            wcs.Command(userid).SetCoolDown('Blinding Aura', 10)

def Blind(userid, attacker):
    es.server.queuecmd('est_Fade %s %s %s %s %s %s %s %s'%(userid,0,1,1,255,255,255,255))
    es.tell(userid, '#multi', '#greenBlinding Aura #default- #lightgreenYou have been blinded by \'#greenAngel\'s#lightgreen\' beauty.')

def player_ultimate_on(ev):
    userid = ev['userid']
    
    wings = wcs.GetLevel(userid, Name, 'Angelic Wings')
    if wings:
        playerlib.getPlayer(userid).set('jetpack', 1)
        es.tell(userid, '#multi', '#greenAngelic Wings #default- #lightgreenYou spread your wings and are able to fly.')

def player_ultimate_off(ev):
    userid = ev['userid']
    
    wings = wcs.GetLevel(userid, Name, 'Angelic Wings')
    if wings:
        playerlib.getPlayer(userid).set('jetpack', 0)
        es.tell(userid, '#multi', '#greenAngelic Wings #default- #lightgreenDeactivated.')				
